﻿package libs {
	import flash.display.BitmapData;
	import flash.geom.Rectangle;

	public class Heart {
		private var opoints:Vector.<uint>;
		private var parts:Array;
		
		public var hbmin:uint = 25;
		public var hbmax:uint = 25;
		
		private var hbcur:uint = 25;
		
		public function Heart(){
			opoints = new <uint>[84, 41, 2, 0xFFFFEEEE,
								113, 128, 5, 0xFFFFEEEE,
								153, 75, 3, 0xFFFFEEEE,
								
								94, 51, 30, 0xFFAA0000,
								123, 138, 30, 0xFFAA0000,
								205, 155, 10, 0xFFAA0000,
								153, 75, 20, 0xFFAA0000,
								
								181, 54, 20, 0xFF990000,
								163, 80, 40, 0xFF990000,
								205, 155, 30, 0xFF990000,
								167, 86, 50, 0xFF880000,
								99, 56, 40, 0xFF880000,
								128, 138, 45, 0xFF880000,
								200, 153, 38, 0xFF880000,
								
								173, 80, 50, 0xFF550000,
								183, 110, 50, 0xFF550000,
								104, 61, 50, 0xFF550000,
								135, 138, 55, 0xFF550000,
								190, 150, 50, 0xFF550000];
			
			parts = new Array();
			parts[0] = [0, 3, 11, 16];
			parts[1] = [1, 4, 12, 17];
			parts[2] = [5, 9, 13, 18];
			parts[3] = [2, 6, 8, 10, 14];
			parts[4] = [7, 15];
			
			for (var i:uint = 0; i < opoints.length; i += 4){
				opoints[i] += 10;
				opoints[i + 1] += 10;
			}
			
			//parts[3] = [];
			
			/*for (var i:uint = 0; i < parts[3].length; i++){
				points[parts[3][i] * 4 + 2] = 1;
			}*/
		}
		
		public var ticker:uint = 0;
		
		public function render(bd:BitmapData):void {
			var i:uint;
			
			var points:Vector.<uint> = new Vector.<uint>;
			for (i = 0; i < opoints.length; i++){
				points[i] = opoints[i];
			}
			if (ticker < 5){
				for (i = 1; i < parts[0].length; i++){
					points[parts[0][i] * 4 + 2] -= ticker * 1.5;
				}
				points[0] += ticker >> 1;
				points[1] += ticker >> 1;
			} else if (ticker < 7){
				for (i = 1; i < parts[0].length; i++){
					points[parts[0][i] * 4 + 2] -= (2 - (ticker - 7));
				}
				points[0] += (2 - (ticker - 7)) >> 1;
				points[1] += (2 - (ticker - 7)) >> 1;
			}
			if (ticker > 2 && ticker < 9){
				for (i = 1; i < parts[1].length; i++){
					points[parts[1][i] * 4 + 2] += (ticker - 3);
					points[parts[1][i] * 4] -= (ticker - 5) * 1.5;
				}
				points[4] -= (ticker - 3);
				points[5] -= (ticker - 3) >> 1;
			} else if (ticker >= 9 && ticker < 15){
				for (i = 1; i < parts[1].length; i++){
					points[parts[1][i] * 4 + 2] += (9 - (ticker - 9));
				}
				points[4] -= (9 - (ticker - 9));
				points[5] -= (9 - (ticker - 9)) >> 1;
			}
			if (ticker < 7){
				for (i = 1; i < parts[3].length; i++){
					points[parts[3][i] * 4 + 2] -= ticker >> 1;
					points[parts[3][i] * 4 + 1] += ticker;
				}
				points[9] += ticker >> 1;
			}
			if (ticker > 5 && ticker < 13){
				for (i = 0; i < parts[2].length; i++){
					points[parts[2][i] * 4 + 2] += (ticker - 5);
					points[parts[2][i] * 4 + 0] -= (ticker - 5);
				}
			} else if (ticker >= 9 && ticker < 15){
				for (i = 0; i < parts[2].length; i++){
					points[parts[2][i] * 4 + 2] += (9 - (ticker - 9));
				}
			}
			if (ticker >= 5 && ticker < 14){
				for (i = 0; i < parts[4].length; i++){
					points[parts[4][i] * 4 + 2] += (ticker - 5) >> 1;
				}
			}
			
			if (ticker == 2){
				Thade.ats.sndHeart.play();
			}
			
			ticker++;
			if (ticker >= hbcur){
				ticker = 0;
				hbcur = (hbmin == hbmax ? hbmin : StaticPRNG.nextIntRange(hbmin, hbmax));
			}
			
			zbuff = new BitmapData(320, 240, true, 0x00FFFFFF);
			for (i = 0; i < points.length; i += 4){
				drawCircle(bd, points[i], points[i + 1], points[i + 2], points[i + 3]);
			}
		}
		
		private var zbuff:BitmapData;
		private function drawCircle(bd:BitmapData, px:uint, py:uint, radius:uint, colour:uint):void {
			if (radius > 100){
				radius = 1;
			}
			var rect:Rectangle = new Rectangle(px - radius, py - radius, radius * 2, radius * 2);
			var zbv:Vector.<uint> = zbuff.getVector(rect);
			var bdv:Vector.<uint> = bd.getVector(rect);
			
			var xp:int = -radius;
			var yp:int = -radius;
			var vch:Boolean = false;
			for (var i:uint = 0; i < bdv.length; i++){
				if ((zbv[i] & 0xFF000000) == 0){
					var dist:Number = Math.sqrt(xp * xp + yp * yp);
					if (dist <= radius){
						vch = true;
						zbv[i] = 0xFFFF0000;
						bdv[i] = colour;
					}
				}
				xp++;
				if (xp >= radius){
					xp = -radius;
					yp++;
				}
			}
			
			if (vch){
				zbuff.setVector(rect, zbv);
				bd.setVector(rect, bdv);
			}
		}
	}
}