﻿package libs {
	public class StaticPRNG {
		protected static var seed:uint = 1;
		
		public static function newSeed(s:uint = 1){
			seed = s;
		}
		
		public static function nextBool():Boolean {
			return (seed = (seed * 16807) % 2147483647) < 1073741824;
		}
		
		public static function nextChance(ch:uint):Boolean {
			return (seed = (seed * 16807) % 2147483647) < ch; // nextInt() < ch
		}
		
		public static function nextDouble():Number {
			return (seed = (seed * 16807) % 2147483647) / 2147483647; // (nextInt() / 2147483647);
		}
		
		public static function nextDoubleRange(min:Number, max:Number):Number {
			return min + ((max - min) * ((seed = (seed * 16807) % 2147483647) / 2147483647)); // min + ((max - min) * nextDouble());
		}
		
		public static function nextInt():uint {
			return seed = (seed * 16807) % 2147483647;
		}
		
		public static function nextIntMod(m:uint):uint {
			return (seed = (seed * 16807) % 2147483647) % m;
		}
		
		public static function nextIntRange(min:Number, max:Number):uint {
			min -= .4999;
			max += .4999;
			return Math.round(min + ((max - min) * ((seed = (seed * 16807) % 2147483647) / 2147483647))); // Math.round(min + ((max - min) * nextDouble()));
		}
	}
}