﻿package libs.mg {
	import libs.MiniGame;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import libs.StaticPRNG;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import libs.Thade;
	import libs.Clock;

	public class MGLightsout extends MiniGame {
		
		private var field:Vector.<Boolean>;
		
		// field w / h
		private var fw:uint;
		private var fh:uint;
		
		// mouse
		private var mo:Boolean = false;
		private var mox:uint = 0;
		private var moy:uint = 0;
		
		private var mr:Boolean = true; // mouse responsive
		
		private var zfr:uint = 0; // lights on
		
		private var lvls:Array = [[[0], 5, 5],
								  [[1, 1, 0, 1, 1,
									1, 0, 1, 0, 1,
									0, 1, 1, 1, 0,
									1, 0, 1, 0, 1,
									1, 1, 0, 1, 1], 5, 5],
								  [[1, 1, 1, 1, 1,
									1, 0, 1, 0, 1,
									1, 1, 0, 1, 1,
									1, 0, 1, 0, 1,
									1, 1, 1, 1, 1], 5, 5],
								  [[1, 1, 0, 0, 0,
									1, 1, 0, 0, 0,
									1, 1, 0, 0, 0,
									1, 1, 0, 0, 0,
									1, 1, 0, 0, 0], 5, 5],
								  [[1, 1, 1, 1, 1,
									1, 1, 0, 0, 1,
									1, 0, 0, 0, 1,
									1, 0, 0, 1, 1,
									1, 1, 1, 1, 1], 5, 5]];
		private var llim:uint = 0;
		private var lnum:uint = 0; // level number
		private var levd:int = 30; // level delay
		//private var levt:int = 300; // level time
		
		private var levdis:Boolean = false;
		
		private function shuffleSort(a:*, b:*):Number {
			return (StaticPRNG.nextIntMod(3) - 1);
		}
		
		public function MGLightsout(){
			/*var bmp:Bitmap = new res();
			resBD = bmp.bitmapData;
			
			bmp = new resf();
			resfBD = bmp.bitmapData;
			
			bmp = new resp();
			respBD = bmp.bitmapData;*/
			
			llim = lvls.length - (2 - Thade.diff);
			
			createField([0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0,
						 0, 0, 0, 0, 0], 5, 5);
			
			levdis = false;
			
			//StaticPRNG.newSeed(1);
			//createLevel(2, 2, 800000000); // 400000000
			//clearLevel();
			//randomiseLevel();
		}
		
		override public function tick(bd:BitmapData):void {
			bd.copyPixels(Thade.ats.bdPipes, new Rectangle(0, 64, 320, 240), new Point(0, 0));
			var i:uint;
			
			if (levdis){
			
				var xp:uint = 0;
				var yp:uint = 0;
				var rf:uint;
				for (i = 0; i < field.length; i++){
					if (field[i]){
						bd.copyPixels(Thade.ats.bdLightsout, new Rectangle(32, 0, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					} else {
						bd.copyPixels(Thade.ats.bdLightsout, new Rectangle(64, 0, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					}
					//var rf:uint = ~(field[i] & 15);
					//rf = field[i]; // & 15;
					
					/*if (rf & 1){
						bd.setPixel32(xp * 16 + 8, yp * 16, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16, 2, 8), 0xFF00FF00);
					}
					
					if (rf & 2){
						bd.setPixel32(xp * 16 + 15, yp * 16 + 8, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16 + 8, 8, 2), 0xFF00FF00);
					}
					
					if (rf & 4){
						bd.setPixel32(xp * 16 + 8, yp * 16 + 15, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16 + 8, 2, 8), 0xFF00FF00);
					}
					
					if (rf & 8){
						bd.setPixel32(xp * 16, yp * 16 + 7, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16, yp * 16 + 8, 8, 2), 0xFF00FF00);
					}*/
					
					/*if (rf & 32 && (rf & 15) == 0){
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(16, 0, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					} else if ((rf & 15) != 0){
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(16 + (rf & 3) * 16, ((rf & 12) >> 2) * 16, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					} else {
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(0, 32, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					}*/
					xp++;
					if (xp == fw){
						xp = 0;
						yp++;
					}
				}
				
				for (i = 0; i < fh; i++){
					bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 16, 5, 16), new Point(fw * 16 + 160 - fw * 8, i * 16 + 120 - fh * 8), null, null, true);
				}
				
				for (i = 0; i < fw; i++){
					bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 32, 16, 5), new Point(i * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				}
				
				bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 48, 5, 5), new Point(fw * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(resBD, new Rectangle(160, 16, 16, 16), new Point(-16 + 160 - fw * 8, sp * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(resBD, new Rectangle(176, (levd > 0 ? 32 : 16), 16, 16), new Point(fw * 16 + 160 - fw * 8, ep * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(resBD, new Rectangle(160, 16, 160, 160), new Point(0, 0), null, null, true);
			
			}
			
			if (Thade.s.mouseX >> 1 > (160 - fw * 8) && Thade.s.mouseX >> 1 < (fw * 16 + 160 - fw * 8) && Thade.s.mouseY >> 1 > (120 - fh * 8) && Thade.s.mouseY >> 1 < (fh * 16 + 120 - fh * 8) && mr && levdis){
				//bd.copyPixels(resBD, new Rectangle(80, 0, 16, 16), new Point(fw * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				var sx:int = (Thade.s.mouseX >> 1) - (160 - fw * 8);
				var sy:int = (Thade.s.mouseY >> 1) - (120 - fh * 8);
				
				mox = Math.floor(sx / 16);
				moy = Math.floor(sy / 16);
				bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 0, 16, 16), new Point(mox * 16 + 160 - fw * 8, moy * 16 + 120 - fh * 8), null, null, true);
				mo = true;
			} else {
				mo = false;
			}
			
			if (mr){
				if (zfr == 0){
					if (levdis){
						Thade.ats.sndLevel.play();
					}
					mr = false;
					levd = 30;
				}
			} else {
				if (levd == -100){
					//
				} else if (levd > 0){
					levd--;
				} else if (levd < 1){
					if (won){
						over = true;
					} else {
						lnum++;
						levdis = true;
						if (lnum >= llim){
							won = true;
							//levdis = false;
							levd = 30;
						} else {
							createField(lvls[lnum][0], lvls[lnum][1], lvls[lnum][2]);
							mr = true;
						}
						//
					}
				}
			}
		}
		
		override public function mclick():void {
			if (mr && mo){
				Thade.ats.sndShuff.play();
				zfr += (field[mox + moy * fw] ? -1 : 1);
				field[mox + moy * fw] = !field[mox + moy * fw];
				if (mox > 0){
					zfr += (field[mox + moy * fw - 1] ? -1 : 1);
					field[mox + moy * fw - 1] = !field[mox + moy * fw - 1];
				}
				if (mox < fw - 1){
					zfr += (field[mox + moy * fw + 1] ? -1 : 1);
					field[mox + moy * fw + 1] = !field[mox + moy * fw + 1];
				}
				if (moy > 0){
					zfr += (field[mox + moy * fw - fw] ? -1 : 1);
					field[mox + moy * fw - fw] = !field[mox + moy * fw - fw];
				}
				if (moy < fh - 1){
					zfr += (field[mox + moy * fw + fw] ? -1 : 1);
					field[mox + moy * fw + fw] = !field[mox + moy * fw + fw];
				}
			}
		}
		
		private function createField(m:Array, w:uint, h:uint):void {
			fw = w;
			fh = h;
			
			zfr = 0;
			
			field = new Vector.<Boolean>(w * h);
			for (var i:uint = 0; i < m.length; i++){
				if (m[i]){
					field[i] = true;
					zfr++;
				}
			}
		}
		
		/*private function createLevel(w:uint, h:uint, spch:uint):Boolean {
			var i:uint;
			
			fw = w;
			fh = h;
			
			var ffree:uint = w * h;
			var unexp:Array = new Array();
			zones = new Array();
			field = new Vector.<uint>(ffree);
			
			for (i = 0; i < ffree; i++){
				unexp[i] = new Array(i % w, (i - (i % w)) / w, false);
			}
			
			while (ffree > 0){
				if (zones.length == 0 || StaticPRNG.nextChance(spch)){
					//trace("spawn");
					//unexp.sort(shuffleSort);
					var unexpi:Array = new Array();
					for (i = 0; i < unexp.length; i++){
						unexpi[i] = i;
					}
					unexpi.sort(shuffleSort);
					for (i = 0; i < unexp.length; i++){
						if (!unexp[unexpi[i]][2]){
							break;
						}
					}
					if (i == unexp.length){
						break;
					}
					unexp[unexpi[i]][2] = true;
					var et:Array = unexp[unexpi[i]];
					zones[zones.length] = new Array(et[0], et[1], new Array(new Array(et[0], et[1], unexpi[i])), 1);
					field[unexpi[i]] = 32;
				} else {
					//trace("expand");
					zones.sort(shuffleSort);
					var dirs:Array = new Array(0, 1, 2, 3);
					dirs.sort(shuffleSort);
					var outbreak:Boolean = true;
					for (i = 0; (i < zones.length && outbreak); i++){
						//trace(zones[i][2]);
						zones[i][2].sort(shuffleSort);
						for (var j:uint = 0; (j < zones[i][2].length && outbreak); j++){
							//trace("a");
							var dir:uint = 5;
							var exp:int = 0;
							for (var k:uint = 0; k < 4; k++){
								switch (dirs[k]){
									case 0:
									if (zones[i][2][j][1] > 0){
										if (!unexp[zones[i][2][j][2] - w][2]){
											dir = 0;
											exp = -w;
										}
									}
									break;
									case 1:
									if (zones[i][2][j][0] < w - 1){
										if (!unexp[zones[i][2][j][2] + 1][2]){
											dir = 1;
											exp = 1;
										}
									}
									break;
									case 2:
									if (zones[i][2][j][1] < h - 1){
										if (!unexp[zones[i][2][j][2] + w][2]){
											dir = 2;
											exp = w;
										}
									}
									break;
									default:
									if (zones[i][2][j][0] > 0){
										if (!unexp[zones[i][2][j][2] - 1][2]){
											dir = 3;
											exp = -1;
										}
									}
								}
								if (dir != 5){
									break;
								}
							}
							if (dir != 5){
								unexp[zones[i][2][j][2] + exp][2] = true;
								zones[i][2][zones[i][2].length] = new Array(unexp[zones[i][2][j][2] + exp][0], unexp[zones[i][2][j][2] + exp][1], zones[i][2][j][2] + exp);
								
								field[zones[i][2][j][2]] |= (1 << dir);
								field[zones[i][2][j][2] + exp] |= (1 << ((dir + 2) % 4));
								
								zones[i][3]++;
								
								outbreak = false;
							}
						}
					}
				}
				ffree--;
			}
			
			zfr = 0;
			
			return true;
		}*/
		
		/*private function clearLevel():void {
			for (var i:uint = 0; i < zones.length; i++){
				for (var j:uint = 0; j < zones[i][2].length; j++){
					field[zones[i][2][j][2]] = 16;
					zfr++;
				}
				field[zones[i][0] + zones[i][1] * fw] = 32;
				zfr--;
				zones[i][2] = new Array(new Array(zones[i][0], zones[i][1], (zones[i][0] + zones[i][1] * fw)));
			}
		}*/
	}
}