﻿package libs.mg {
	import libs.MiniGame;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import libs.StaticPRNG;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import libs.Thade;
	import libs.Clock;

	public class MGPipes extends MiniGame {
		/*[Embed(source="../../../res/pipes.png")] private var res:Class;
		private var resBD:BitmapData;*/
		
		private var field:Vector.<uint>;
		
		// field w / h
		private var fw:uint = 0;
		private var fh:uint = 0;
		
		// start point / end point
		private var sp:uint = 0;
		private var ep:uint = 0;
		
		// mouse
		private var mo:Boolean = false;
		private var mox:uint = 0;
		private var moy:uint = 0;
		
		private var mr:Boolean = false; // mouse responsive
		
		private var lsiz:Array = [[5, 3],
								  [5, 3],
								  [6, 4],
								  [6, 4],
								  [8, 6],
								  [8, 6],
								  [12, 8],
								  [12, 8],
								  [15, 10],
								  [15, 10],
								  [16, 13],
								  [16, 13],
								  [18, 14]];
		private var llim:uint = 0;
		private var lnum:uint = 0; // level number
		private var levd:int = 120; // level delay
		private var levt:int = 300; // level time
		
		private var llost:Boolean = false;
		
		private var cl:Clock;
		
		private var levdis:Boolean = false;
		
		private function shuffleSort(a:*, b:*):Number {
			return (StaticPRNG.nextIntMod(3) - 1);
		}
		
		public function MGPipes(){
			/*var bmp:Bitmap = new res();
			resBD = bmp.bitmapData;*/
			
			llim = lsiz.length;
			
			cl = new Clock();
			
			StaticPRNG.newSeed(1);
			createLevel(2, 2);
			randomiseLevel();
		}
		
		override public function tick(bd:BitmapData):void {
			bd.copyPixels(Thade.ats.bdPipes, new Rectangle(0, 64, 320, 240), new Point(0, 0));
			
			if (levdis){
			
				var xp:uint = 0;
				var yp:uint = 0;
				for (var i:uint = 0; i < field.length; i++){
					//var rf:uint = ~(field[i] & 15);
					var rf:uint = field[i]; // & 15;
					
					/*if (rf & 1){
						bd.setPixel32(xp * 16 + 8, yp * 16, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16, 2, 8), 0xFF00FF00);
					}
					
					if (rf & 2){
						bd.setPixel32(xp * 16 + 15, yp * 16 + 8, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16 + 8, 8, 2), 0xFF00FF00);
					}
					
					if (rf & 4){
						bd.setPixel32(xp * 16 + 8, yp * 16 + 15, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16 + 8, 2, 8), 0xFF00FF00);
					}
					
					if (rf & 8){
						bd.setPixel32(xp * 16, yp * 16 + 7, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16, yp * 16 + 8, 8, 2), 0xFF00FF00);
					}*/
					
					bd.copyPixels(Thade.ats.bdPipes, new Rectangle(16 + (rf & 3) * 16 + (rf & 16 ? 80 : 0), ((rf & 12) >> 2) * 16, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					xp++;
					if (xp == fw){
						xp = 0;
						yp++;
					}
				}
				
				for (i = 0; i < fh; i++){
					bd.copyPixels(Thade.ats.bdPipes, new Rectangle(80, 16, 5, 16), new Point(fw * 16 + 160 - fw * 8, i * 16 + 120 - fh * 8), null, null, true);
				}
				
				for (i = 0; i < fw; i++){
					bd.copyPixels(Thade.ats.bdPipes, new Rectangle(80, 32, 16, 5), new Point(i * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				}
				
				bd.copyPixels(Thade.ats.bdPipes, new Rectangle(80, 48, 5, 5), new Point(fw * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				bd.copyPixels(Thade.ats.bdPipes, new Rectangle(160, 16, 16, 16), new Point(-16 + 160 - fw * 8, sp * 16 + 120 - fh * 8), null, null, true);
				bd.copyPixels(Thade.ats.bdPipes, new Rectangle(176, ((levd > 0 && !llost) ? 32 : 16), 16, 16), new Point(fw * 16 + 160 - fw * 8, ep * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(Thade.ats.bdPipes, new Rectangle(160, 16, 160, 160), new Point(0, 0), null, null, true);
			
			}
			
			if (Thade.s.mouseX >> 1 > (160 - fw * 8) && Thade.s.mouseX >> 1 < (fw * 16 + 160 - fw * 8) && Thade.s.mouseY >> 1 > (120 - fh * 8) && Thade.s.mouseY >> 1 < (fh * 16 + 120 - fh * 8) && mr){
				//bd.copyPixels(Thade.ats.bdPipes, new Rectangle(80, 0, 16, 16), new Point(fw * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				var sx:int = (Thade.s.mouseX >> 1) - (160 - fw * 8);
				var sy:int = (Thade.s.mouseY >> 1) - (120 - fh * 8);
				
				mox = Math.floor(sx / 16);
				moy = Math.floor(sy / 16);
				bd.copyPixels(Thade.ats.bdPipes, new Rectangle(80, 0, 16, 16), new Point(mox * 16 + 160 - fw * 8, moy * 16 + 120 - fh * 8), null, null, true);
				mo = true;
			} else {
				mo = false;
			}
			
			if (mr){
				levt -= 1;
				if (levt < 1){
					llost = true;
					mr = false;
					//over = true;
					levd = 30;
				}
			} else {
				if (levd == -100){
					//
				} else if (levd > 0){
					levd--;
				} else if (levd < 1){
					if (llost){
						over = true;
					} else {
						lnum++;
						levt = 300;
						levdis = true;
						createLevel(lsiz[lnum][0], lsiz[lnum][1]);
						if (lnum > (4 + Thade.diff)){
							won = true;
						}
						randomiseLevel();
						mr = true;
					}
				}
			}
			
			cl.render(bd, levt);
		}
		
		override public function mclick():void {
			if (mo && mr){
				var rf:uint = (field[mox + moy * fw] & 15) >> 3;
				field[mox + moy * fw] = ((field[mox + moy * fw] << 1) & 15) | rf;
				Thade.ats.sndShuff.play();
				if (highlightLevel() && lnum < llim){
					Thade.ats.sndLevel.play();
					mr = false;
					levd = 30;
				}
			}
		}
		
		private function createLevel(w:uint, h:uint):Boolean {
			var i:uint;
			
			fw = w;
			fh = h;
			
			//var lbd:BitmapData = new BitmapData(w, h, true, 0xFFFF0000);
			sp = StaticPRNG.nextIntMod(h);
			ep = StaticPRNG.nextIntMod(h);
			
			/*lbd.setPixel32(0, sp, 0xFF0000FF);
			lbd.setPixel32(w - 1, ep, 0xFF0000FF);*/
			
			//var done:Array = new Array();
			var unexp:Array = new Array();
			
			// x y dir
			unexp[0] = new Array(0, sp, 2 + (sp == 0 ? 0 : 1) + (sp == (h - 1) ? 0 : 4));
			
			//var lbdv:Vector.<uint> = lbd.getVector(lbd.rect);
			field = new Vector.<uint>(w * h);
			var fieldexp:Vector.<Boolean> = new Vector.<Boolean>(field.length);
			
			field[sp * w] = 8;
			
			/*
			 1
			8 2
			 4
			*/
			
			var infs:uint = 0;
			while (infs++ < 5000){
				unexp.sort(shuffleSort);
				for (i = 0; i < unexp.length; i++){
					if (unexp[i][2] > 0){
						break;
					}
				}
				
				if (i == unexp.length){
					break;
				}
				
				var dir:uint = 0;
				var tmp:uint;
				switch (unexp[i][2]){
					case 0: return false; break;
					case 1: dir = 0; break;
					case 2: dir = 1; break;
					case 3: dir = StaticPRNG.nextIntMod(2); break;
					case 4: dir = 2; break;
					case 5: dir = (StaticPRNG.nextBool() ? 2 : 0); break;
					case 6: dir = 1 + StaticPRNG.nextIntMod(2); break;
					case 7: dir = StaticPRNG.nextIntMod(3); break;
					case 8: dir = 3; break;
					case 9: dir = (StaticPRNG.nextBool() ? 3 : 0); break;
					case 10:dir = 1 + (StaticPRNG.nextBool() ? 2 : 0); break;
					case 11:tmp = StaticPRNG.nextIntMod(2); dir = (tmp == 2 ? 3 : tmp); break;
					case 12:dir = 2 + StaticPRNG.nextIntMod(2); break;
					case 13:tmp = StaticPRNG.nextIntMod(2); dir = (tmp == 0 ? 0 : tmp + 1); break;
					case 14:dir = 1 + StaticPRNG.nextIntMod(3); break;
					case 15:dir = StaticPRNG.nextIntMod(4); break;
				}
				
				//trace("expanding on " + unexp[i][0] + ", " + unexp[i][1] + " (" + unexp[i][2] + ") - dir: " + dir);
				
				var cur:uint = unexp[i][0] + (unexp[i][1] * w);
				var exp:int = 0;
				var expx:int = 0;
				var expy:int = 0;
				var idir:uint = 0;
				switch (dir){
					case 0: exp = -w; expy = -1; idir = 11; break;
					case 1: exp = 1; expx = 1; idir = 7; break;
					case 2: exp = w; expy = 1; idir = 14; break;
					default: exp = -1; expx = -1; idir = 13;
				}
				
				var expcur:int = exp + cur;
				
				if (expcur == cur){
					continue;
				} else if (expcur < 0 || expcur >= field.length || (unexp[i][0] + expx) < 0 || (unexp[i][1] + expy) < 0 || (unexp[i][0] + expx) >= w || (unexp[i][1] + expy) >= h){
					unexp[i][2] = unexp[i][2] ^ (1 << dir);
					field[cur] = field[cur] | (1 << dir);
				} else if (fieldexp[expcur]){
					//trace("boop");
					unexp[i][2] = unexp[i][2] ^ (1 << dir);
					field[cur] = field[cur] | (1 << dir);
				} else {
					//trace("added " + (unexp[i][0] + expx) + ", " + (unexp[i][1] + expy) + ", " + idir);
					unexp[i][2] = unexp[i][2] ^ (1 << dir);
					unexp[unexp.length] = new Array(unexp[i][0] + expx, unexp[i][1] + expy, idir);
					fieldexp[expcur] = true;
				}
			}
			
			//trace("Took " + infs + " loops.");
			
			/*for (i = 0; i < unexp.length; i++){
				field[unexp[i][0] + (unexp[i][1] * w)] = 1;
				/*if (lbdv[i] == 0xFF0000FF){
					field[i] = 1;
				} else {
					field[i] = 0;
				}* /
			}*/
			
			field[sp * fw] = 0;
			field[ep * fw + fw - 1] = 0;
			
			return true;
		}
		
		private function randomiseLevel():void {
			for (var i:uint = 0; i < field.length; i++){
				var sh:uint = StaticPRNG.nextIntMod(4);
				var rf:uint = (field[i] & 15) >> (4 - sh);
				field[i] = ((field[i] << sh) & 15) | rf;
			}
			highlightLevel();
		}
		
		private function highlightLevel():Boolean {
			var i:uint;
			
			var unexp:Array = new Array();
			unexp[0] = new Array(0, sp, true);
			
			for (i = 0; i < field.length; i++){
				field[i] = field[i] & 15;
			}
			
			if ((field[sp * fw] & 8) != 0){
				return false;
			}
			
			var epf:Boolean = false;
			while (true){
				for (i = 0; i < unexp.length; i++){
					if (unexp[i][2]){
						break;
					}
				}
				
				if (i == unexp.length){
					break;
				}
				
				unexp[i][2] = false;
				
				var rf:uint = (field[unexp[i][0] + unexp[i][1] * fw] |= 16);
				var val:uint = 0;
				
				if (unexp[i][0] == fw - 1 && unexp[i][1] == ep && (rf & 2) == 0){
					epf = true;
				}
				
				if ((rf & 1) == 0 && unexp[i][1] > 0){
					val = field[unexp[i][0] + ((unexp[i][1] - 1) * fw)];
					if ((val & 4) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0], unexp[i][1] - 1, true);
					}
				}
				if ((rf & 2) == 0 && unexp[i][0] < (fw - 1)){
					val = field[unexp[i][0] + 1 + unexp[i][1] * fw];
					if ((val & 8) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0] + 1, unexp[i][1], true);
					}
				}
				if ((rf & 4) == 0 && unexp[i][1] < (fh - 1)){
					val = field[unexp[i][0] + ((unexp[i][1] + 1) * fw)];
					if ((val & 1) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0], unexp[i][1] + 1, true);
					}
				}
				if ((rf & 8) == 0 && unexp[i][0] > 0){
					val = field[unexp[i][0] - 1 + unexp[i][1] * fw];
					if ((val & 2) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0] - 1, unexp[i][1], true);
					}
				}
			}
			
			return epf;
		}
	}
}