﻿package libs.mg {
	import libs.MiniGame;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import libs.StaticPRNG;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import libs.Thade;
	import libs.Clock;
	import libs.FontRenderer;

	public class MGZones extends MiniGame {
		/*[Embed(source="../../../res/zones.png")] private var res:Class;
		private var resBD:BitmapData;
		[Embed(source="../../../res/font.png")] private var resf:Class;
		private var resfBD:BitmapData;
		[Embed(source="../../../res/pipes.png")] private var resp:Class;
		private var respBD:BitmapData;*/
		
		private var zones:Array;
		private var field:Vector.<uint>;
		
		// field w / h
		private var fw:uint = 0;
		private var fh:uint = 0;
		
		// mouse
		private var mo:Boolean = false;
		private var mox:uint = 0;
		private var moy:uint = 0;
		
		private var mlox:uint = 0;
		private var mloy:uint = 0;
		
		private var mr:Boolean = false; // mouse responsive
		
		private var mdo:Boolean = false; // mouse down
		private var mzss:Boolean = false; // zone really selected
		private var mzs:uint = 0; // zone selected
		
		private var zfr:uint = 0; // free tiles
		
		private var lsiz:Array = [[5, 3, 800000000],
								  [5, 3, 800000000],
								  [6, 4, 800000000],
								  [6, 4, 800000000],
								  [8, 6, 800000000],
								  [8, 6, 800000000],
								  [12, 8, 1000000000],
								  [12, 8, 800000000],
								  [15, 10, 800000000],
								  [15, 10, 800000000],
								  [16, 13, 800000000],
								  [16, 13, 800000000],
								  [18, 14, 800000000]];
		private var llim:uint = 0;
		private var lnum:uint = 0; // level number
		private var levd:int = 30; // level delay
		//private var levt:int = 300; // level time
		
		private var levdis:Boolean = false;
		
		private function shuffleSort(a:*, b:*):Number {
			return (StaticPRNG.nextIntMod(3) - 1);
		}
		
		public function MGZones(){
			/*var bmp:Bitmap = new res();
			resBD = bmp.bitmapData;
			
			bmp = new resf();
			resfBD = bmp.bitmapData;
			
			bmp = new resp();
			respBD = bmp.bitmapData;*/
			
			llim = lsiz.length;
			//llim = 2;
			
			StaticPRNG.newSeed(1);
			createLevel(2, 2, 800000000); // 400000000
			clearLevel();
			//randomiseLevel();
		}
		
		override public function tick(bd:BitmapData):void {
			bd.copyPixels(Thade.ats.bdPipes, new Rectangle(0, 64, 320, 240), new Point(0, 0));
			var i:uint;
			
			if (levdis){
			
				var xp:uint = 0;
				var yp:uint = 0;
				var rf:uint;
				for (i = 0; i < field.length; i++){
					//var rf:uint = ~(field[i] & 15);
					rf = field[i]; // & 15;
					
					/*if (rf & 1){
						bd.setPixel32(xp * 16 + 8, yp * 16, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16, 2, 8), 0xFF00FF00);
					}
					
					if (rf & 2){
						bd.setPixel32(xp * 16 + 15, yp * 16 + 8, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16 + 8, 8, 2), 0xFF00FF00);
					}
					
					if (rf & 4){
						bd.setPixel32(xp * 16 + 8, yp * 16 + 15, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16 + 8, yp * 16 + 8, 2, 8), 0xFF00FF00);
					}
					
					if (rf & 8){
						bd.setPixel32(xp * 16, yp * 16 + 7, 0xFFFF0000);
					} else {
						bd.fillRect(new Rectangle(xp * 16, yp * 16 + 8, 8, 2), 0xFF00FF00);
					}*/
					
					if (rf & 32 && (rf & 15) == 0){
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(16, 0, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					} else if ((rf & 15) != 0){
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(16 + (rf & 3) * 16, ((rf & 12) >> 2) * 16, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					} else {
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(0, 32, 16, 16), new Point(xp * 16 + 160 - fw * 8, yp * 16 + 120 - fh * 8));
					}
					xp++;
					if (xp == fw){
						xp = 0;
						yp++;
					}
				}
				
				if (mzss){
					for (i = 0; i < zones[mzs][2].length; i++){
						rf = field[zones[mzs][2][i][0] + zones[mzs][2][i][1] * fw];
						bd.copyPixels(Thade.ats.bdZones, new Rectangle(16 + (rf & 3) * 16 + 80, ((rf & 12) >> 2) * 16, 16, 16), new Point(zones[mzs][2][i][0] * 16 + 160 - fw * 8, zones[mzs][2][i][1] * 16 + 120 - fh * 8));
					}
				}
				
				for (i = 0; i < zones.length; i++){
					var zc:uint;
					if (zones[i][3] < 10){
						zc = zones[i][3]+ 16;
						bd.copyPixels(Thade.ats.bdFont, new Rectangle((zc % 8) * 8, (zc - (zc % 8)), 8, 8), new Point(4 + zones[i][0] * 16 + 160 - fw * 8, 4 + zones[i][1] * 16 + 120 - fh * 8), null, null, true);
					} else {
						zc = Math.floor(zones[i][3] / 10) + 16;
						bd.copyPixels(Thade.ats.bdFont, new Rectangle((zc % 8) * 8, (zc - (zc % 8)), 8, 8), new Point(1 + zones[i][0] * 16 + 160 - fw * 8, 4 + zones[i][1] * 16 + 120 - fh * 8), null, null, true);
						zc = (zones[i][3] % 10) + 16;
						bd.copyPixels(Thade.ats.bdFont, new Rectangle((zc % 8) * 8, (zc - (zc % 8)), 8, 8), new Point(6 + zones[i][0] * 16 + 160 - fw * 8, 4 + zones[i][1] * 16 + 120 - fh * 8), null, null, true);
					}
				}
				
				for (i = 0; i < fh; i++){
					bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 16, 5, 16), new Point(fw * 16 + 160 - fw * 8, i * 16 + 120 - fh * 8), null, null, true);
				}
				
				for (i = 0; i < fw; i++){
					bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 32, 16, 5), new Point(i * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				}
				
				bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 48, 5, 5), new Point(fw * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(resBD, new Rectangle(160, 16, 16, 16), new Point(-16 + 160 - fw * 8, sp * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(resBD, new Rectangle(176, (levd > 0 ? 32 : 16), 16, 16), new Point(fw * 16 + 160 - fw * 8, ep * 16 + 120 - fh * 8), null, null, true);
				//bd.copyPixels(resBD, new Rectangle(160, 16, 160, 160), new Point(0, 0), null, null, true);
			
			}
			
			if (Thade.s.mouseX >> 1 > (160 - fw * 8) && Thade.s.mouseX >> 1 < (fw * 16 + 160 - fw * 8) && Thade.s.mouseY >> 1 > (120 - fh * 8) && Thade.s.mouseY >> 1 < (fh * 16 + 120 - fh * 8) && mr){
				//bd.copyPixels(resBD, new Rectangle(80, 0, 16, 16), new Point(fw * 16 + 160 - fw * 8, fh * 16 + 120 - fh * 8), null, null, true);
				var sx:int = (Thade.s.mouseX >> 1) - (160 - fw * 8);
				var sy:int = (Thade.s.mouseY >> 1) - (120 - fh * 8);
				
				mox = Math.floor(sx / 16);
				moy = Math.floor(sy / 16);
				bd.copyPixels(Thade.ats.bdZones, new Rectangle(80, 0, 16, 16), new Point(mox * 16 + 160 - fw * 8, moy * 16 + 120 - fh * 8), null, null, true);
				mo = true;
				
				if (mzss && (mlox != mox || mloy != moy) && zones[mzs][2].length < zones[mzs][3]){
					for (i = 0; i < zones[mzs][2].length; i++){
						if (zones[mzs][2][i][0] == mlox && zones[mzs][2][i][1] == mloy){
							break;
						}
					}
					if (i < zones[mzs][2].length){
						var et:uint = mox + moy * fw;
						if ((field[et] & 16) != 0){
							if ((mlox == mox + 1 && mloy == moy) ||
								(mlox == mox - 1 && mloy == moy) ||
								(mlox == mox && mloy == moy + 1) ||
								(mlox == mox && mloy == moy - 1)){
								field[et] = 0;
								for (i = 0; i < zones[mzs][2].length; i++){
									if ((zones[mzs][2][i][2] - et) == -1){
										field[zones[mzs][2][i][2]] |= 2;
										field[et] |= 8;
									}
									if ((zones[mzs][2][i][2] - et) == 1){
										field[zones[mzs][2][i][2]] |= 8;
										field[et] |= 2;
									}
									if ((zones[mzs][2][i][2] - et) == fw){
										field[zones[mzs][2][i][2]] |= 1;
										field[et] |= 4;
									}
									if ((zones[mzs][2][i][2] - et) == -fw){
										field[zones[mzs][2][i][2]] |= 4;
										field[et] |= 1;
									}
								}
								Thade.ats.sndShuff.play();
								zones[mzs][2][i] = new Array(mox, moy, et);
								zfr--;
							}
						}
					}
				}
				
				mlox = mox;
				mloy = moy;
			} else {
				mo = false;
			}
			
			if (mr){
				if (zfr == 0){
					Thade.ats.sndLevel.play();
					mr = false;
					levd = 30;
				}
			} else {
				if (levd == -100){
					//
				} else if (levd > 0){
					levd--;
				} else if (levd < 1){
					if (won){
						over = true;
					} else {
						lnum++;
						levdis = true;
						if (lnum > (5 + Thade.diff)){
							won = true;
							//levdis = false;
							levd = 30;
						} else {
							createLevel(lsiz[lnum][0], lsiz[lnum][1], lsiz[lnum][2]);
							clearLevel();
							mr = true;
							mdo = false;
							mzss = false;
						}
						//
					}
				}
			}
			
			var hinttxt:String = "DRAG & DROP, DOUBLE CLICK TO CLEAR";
			bd.copyPixels(Thade.ats.bdMenusplash, new Rectangle(0, 240, 8, 16), new Point(304 - hinttxt.length * 8, 224));
			for (var j:uint = 0; j < hinttxt.length; j++){
				bd.copyPixels(Thade.ats.bdMenusplash, new Rectangle(8, 240, 8, 16), new Point(312 - ((hinttxt.length - j) * 8), 224));
			}
			bd.copyPixels(Thade.ats.bdMenusplash, new Rectangle(16, 240, 8, 16), new Point(312, 224));
			FontRenderer.render(bd, 312 - j * 8, 228, hinttxt);
		}
		
		override public function mdclick():void {
			if (mo && mr){
				for (var i:uint = 0; i < zones.length; i++){
					if (zones[i][0] == mox && zones[i][1] == moy){
						break;
					}
					//for (var j:uint = 0; j < zones[i][2].le
				}
				if (i < zones.length){
					Thade.ats.sndShuff.play();
					for (var j:uint = 0; j < zones[i][2].length; j++){
						field[zones[i][2][j][2]] = 16;
						zfr++;
					}
					field[zones[i][0] + zones[i][1] * fw] = 32;
					zfr--;
					zones[i][2] = new Array(new Array(zones[i][0], zones[i][1], (zones[i][0] + zones[i][1] * fw)));
				}
			}
		}
		
		override public function mdown():void {
			if (mo && mr && !mdo){
				for (var i:uint = 0; i < zones.length; i++){
					if (zones[i][0] == mox && zones[i][1] == moy){
						break;
					}
					//for (var j:uint = 0; j < zones[i][2].le
				}
				if (i < zones.length){
					mzs = i;
					mzss = true;
				}
				mdo = true;
				/*var rf:uint = (field[mox + moy * fw] & 15) >> 3;
				field[mox + moy * fw] = ((field[mox + moy * fw] << 1) & 15) | rf;
				if (highlightLevel() && lnum < llim){
					mr = false;
					levd = 30;
				}*/
			}
		}
		
		override public function mup():void {
			if (mr && mdo){
				mdo = false;
				mzs = 0;
				mzss = false;
				/*var rf:uint = (field[mox + moy * fw] & 15) >> 3;
				field[mox + moy * fw] = ((field[mox + moy * fw] << 1) & 15) | rf;
				if (highlightLevel() && lnum < llim){
					mr = false;
					levd = 30;
				}*/
			}
		}
		
		private function createLevel(w:uint, h:uint, spch:uint):Boolean {
			var i:uint;
			
			fw = w;
			fh = h;
			
			var ffree:uint = w * h;
			var unexp:Array = new Array();
			zones = new Array();
			field = new Vector.<uint>(ffree);
			
			for (i = 0; i < ffree; i++){
				unexp[i] = new Array(i % w, (i - (i % w)) / w, false);
			}
			
			while (ffree > 0){
				if (zones.length == 0 || StaticPRNG.nextChance(spch)){
					//trace("spawn");
					//unexp.sort(shuffleSort);
					var unexpi:Array = new Array();
					for (i = 0; i < unexp.length; i++){
						unexpi[i] = i;
					}
					unexpi.sort(shuffleSort);
					for (i = 0; i < unexp.length; i++){
						if (!unexp[unexpi[i]][2]){
							break;
						}
					}
					if (i == unexp.length){
						break;
					}
					unexp[unexpi[i]][2] = true;
					var et:Array = unexp[unexpi[i]];
					zones[zones.length] = new Array(et[0], et[1], new Array(new Array(et[0], et[1], unexpi[i])), 1);
					field[unexpi[i]] = 32;
				} else {
					//trace("expand");
					zones.sort(shuffleSort);
					var dirs:Array = new Array(0, 1, 2, 3);
					dirs.sort(shuffleSort);
					var outbreak:Boolean = true;
					for (i = 0; (i < zones.length && outbreak); i++){
						//trace(zones[i][2]);
						zones[i][2].sort(shuffleSort);
						for (var j:uint = 0; (j < zones[i][2].length && outbreak); j++){
							//trace("a");
							var dir:uint = 5;
							var exp:int = 0;
							for (var k:uint = 0; k < 4; k++){
								switch (dirs[k]){
									case 0:
									if (zones[i][2][j][1] > 0){
										if (!unexp[zones[i][2][j][2] - w][2]){
											dir = 0;
											exp = -w;
										}
									}
									break;
									case 1:
									if (zones[i][2][j][0] < w - 1){
										if (!unexp[zones[i][2][j][2] + 1][2]){
											dir = 1;
											exp = 1;
										}
									}
									break;
									case 2:
									if (zones[i][2][j][1] < h - 1){
										if (!unexp[zones[i][2][j][2] + w][2]){
											dir = 2;
											exp = w;
										}
									}
									break;
									default:
									if (zones[i][2][j][0] > 0){
										if (!unexp[zones[i][2][j][2] - 1][2]){
											dir = 3;
											exp = -1;
										}
									}
								}
								if (dir != 5){
									break;
								}
							}
							if (dir != 5){
								unexp[zones[i][2][j][2] + exp][2] = true;
								zones[i][2][zones[i][2].length] = new Array(unexp[zones[i][2][j][2] + exp][0], unexp[zones[i][2][j][2] + exp][1], zones[i][2][j][2] + exp);
								
								field[zones[i][2][j][2]] |= (1 << dir);
								field[zones[i][2][j][2] + exp] |= (1 << ((dir + 2) % 4));
								
								zones[i][3]++;
								
								outbreak = false;
							}
						}
					}
				}
				ffree--;
			}
			
			zfr = 0;
			
			return true;
		}
		
		private function clearLevel():void {
			for (var i:uint = 0; i < zones.length; i++){
				for (var j:uint = 0; j < zones[i][2].length; j++){
					field[zones[i][2][j][2]] = 16;
					zfr++;
				}
				field[zones[i][0] + zones[i][1] * fw] = 32;
				zfr--;
				zones[i][2] = new Array(new Array(zones[i][0], zones[i][1], (zones[i][0] + zones[i][1] * fw)));
			}
		}
		/*
		private function randomiseLevel():void {
			for (var i:uint = 0; i < field.length; i++){
				var sh:uint = StaticPRNG.nextIntMod(4);
				var rf:uint = (field[i] & 15) >> (4 - sh);
				field[i] = ((field[i] << sh) & 15) | rf;
			}
			highlightLevel();
		}
		
		private function highlightLevel():Boolean {
			var i:uint;
			
			var unexp:Array = new Array();
			unexp[0] = new Array(0, sp, true);
			
			for (i = 0; i < field.length; i++){
				field[i] = field[i] & 15;
			}
			
			if ((field[sp * fw] & 8) != 0){
				return false;
			}
			
			var epf:Boolean = false;
			while (true){
				for (i = 0; i < unexp.length; i++){
					if (unexp[i][2]){
						break;
					}
				}
				
				if (i == unexp.length){
					break;
				}
				
				unexp[i][2] = false;
				
				var rf:uint = (field[unexp[i][0] + unexp[i][1] * fw] |= 16);
				var val:uint = 0;
				
				if (unexp[i][0] == fw - 1 && unexp[i][1] == ep && (rf & 2) == 0){
					epf = true;
				}
				
				if ((rf & 1) == 0 && unexp[i][1] > 0){
					val = field[unexp[i][0] + ((unexp[i][1] - 1) * fw)];
					if ((val & 4) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0], unexp[i][1] - 1, true);
					}
				}
				if ((rf & 2) == 0 && unexp[i][0] < (fw - 1)){
					val = field[unexp[i][0] + 1 + unexp[i][1] * fw];
					if ((val & 8) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0] + 1, unexp[i][1], true);
					}
				}
				if ((rf & 4) == 0 && unexp[i][1] < (fh - 1)){
					val = field[unexp[i][0] + ((unexp[i][1] + 1) * fw)];
					if ((val & 1) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0], unexp[i][1] + 1, true);
					}
				}
				if ((rf & 8) == 0 && unexp[i][0] > 0){
					val = field[unexp[i][0] - 1 + unexp[i][1] * fw];
					if ((val & 2) == 0 && (val & 16) == 0){
						unexp[unexp.length] = new Array(unexp[i][0] - 1, unexp[i][1], true);
					}
				}
			}
			
			return epf;
		}
		*/
	}
}